/**
 * REST API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * Contact: bla@bla.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { ApplianceDto } from '../model/applianceDto';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class ApplianceControllerService {

    protected basePath = 'https://192.168.18.4:8001';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * createAppliance
     * 
     * @param applianceDto applianceDto
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public createApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'body', reportProgress?: boolean): Observable<ApplianceDto>;
    public createApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ApplianceDto>>;
    public createApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ApplianceDto>>;
    public createApplianceUsingPOST(applianceDto: ApplianceDto, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (applianceDto === null || applianceDto === undefined) {
            throw new Error('Required parameter applianceDto was null or undefined when calling createApplianceUsingPOST.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<ApplianceDto>(`${this.basePath}/exam/createAppliance`,
            applianceDto,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * deleteAppliance
     * 
     * @param applianceDto applianceDto
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public deleteApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'body', reportProgress?: boolean): Observable<any>;
    public deleteApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    public deleteApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    public deleteApplianceUsingPOST(applianceDto: ApplianceDto, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (applianceDto === null || applianceDto === undefined) {
            throw new Error('Required parameter applianceDto was null or undefined when calling deleteApplianceUsingPOST.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<any>(`${this.basePath}/exam/deleteAppliance`,
            applianceDto,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * findAllAppliance
     * 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public findAllApplianceUsingGET1(observe?: 'body', reportProgress?: boolean): Observable<Array<ApplianceDto>>;
    public findAllApplianceUsingGET1(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<ApplianceDto>>>;
    public findAllApplianceUsingGET1(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<ApplianceDto>>>;
    public findAllApplianceUsingGET1(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.get<Array<ApplianceDto>>(`${this.basePath}/exam/findAllAppliance`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * updateAppliance
     * 
     * @param applianceDto applianceDto
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public updateApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'body', reportProgress?: boolean): Observable<ApplianceDto>;
    public updateApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ApplianceDto>>;
    public updateApplianceUsingPOST(applianceDto: ApplianceDto, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ApplianceDto>>;
    public updateApplianceUsingPOST(applianceDto: ApplianceDto, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (applianceDto === null || applianceDto === undefined) {
            throw new Error('Required parameter applianceDto was null or undefined when calling updateApplianceUsingPOST.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            '*/*'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.post<ApplianceDto>(`${this.basePath}/exam/updateAppliance`,
            applianceDto,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
